
-- General functions specific to Hytbold

function FilterNewQuests(QUESTNAME)

	--Debug("New Quest: " .. QUESTNAME);

end


function FilterCompletedQuests(QUESTNAME)

	QUESTNAME = string.gsub(QUESTNAME,_LANG.QUESTS.COMPLETEDQUEST[SETTINGS.LANGUAGE],"");
	QUESTNAME = string.gsub(QUESTNAME,"\n","");

	local i,j = GetQuestID(QUESTNAME);

	if i ~= 0 then -- Quest found

		_CHARDATA[MYCHAR:GetName()]["HYTBOLD"][i][j] = true; -- Mark as completed

		if _QUESTSTRINGS[i][j]["CHECK"] ~= nil and MYCHAR:GetName() == SELECTEDCHARACTER then _QUESTSTRINGS[i][j]["CHECK"]:SetChecked(true) end;

		Debug(PLUGINNAME .. ": <rgb=#00FF00>" .. QUESTNAME .. "</rgb> - " .. _LANG.FOUND[SETTINGS.LANGUAGE]);

	end

end


function CheckCharData()

	-- This function checks if there is an entry in the _CHARDATA table, if not then it creates it.
	local CHARNAME = MYCHAR:GetName();

	if type (_CHARDATA[CHARNAME]) ~= 'table' then _CHARDATA[CHARNAME] = {} end;

	CheckHytboldData(_CHARDATA[CHARNAME]);

end


function CheckHytboldData(_TABLE)

	if type (_TABLE) ~= 'table' then return end;

	-- Checks if the table exists in the characters data, if so then it adds any newer fields that may have been
	-- added in newer updates whilst retaining the values of old values that have been loaded.

	if _TABLE["TOKENS"] == nil then _TABLE["TOKENS"] = 0 end;
	if _TABLE["DAILY"] == nil then _TABLE["DAILY"] = 0 end;
	if _TABLE["HYTBOLD"] == nil then _TABLE["HYTBOLD"] = {} end;


	for k,v in pairs(_QUESTSTRINGS) do
		if _TABLE["HYTBOLD"][k] == nil then _TABLE["HYTBOLD"][k] = {} end;

		for kk,vv in pairs (v) do
			if _TABLE["HYTBOLD"][k][kk] == nil then _TABLE["HYTBOLD"][k][kk] = false end;
		end
	end

end


function GetArmourPrereq(ARMOURID)

	if ARMOURID == nil then return end;

	-- This function searches through the queststring table to find which quest matches the armour ID.

	for i=1, table.getn(_QUESTSTRINGS) do
		for k,v in pairs (_QUESTSTRINGS[i]) do
			if v.ARMOUR == ARMOURID then return i,k end;
		end
	end

	return 1,1;

end


function GetQuestID(QUESTNAME)

	if QUESTNAME == nil then return end;

	-- This function searches through the queststring table to find the quest ID.

	for i=1, table.getn(_QUESTSTRINGS) do
		for k,v in pairs (_QUESTSTRINGS[i]) do
			if v.STRINGS[SETTINGS.LANGUAGE] == QUESTNAME then return i,k end;
		end
	end

	return 0,0;

end


function GetSetID(SETNAME)

	if SETNAME == nil then return end;

	-- This function searches for the SET ID based on the set name
	for k,v in pairs (_SETS) do
		if v.NAME[SETTINGS.LANGUAGE] == SETNAME then return k end;
	end

	return nil;
end


function GetAltNames()

	-- This function gets the names of the alts which have data stored and builds the names into a returned table.
	local _ALTS = {};

	for k,v in pairs (_CHARDATA) do
		table.insert(_ALTS,k);
	end

	return _ALTS;
end


function GetClassName(ID)

	-- This function searches the class table for the name matching the GetClass() ID.
	if ID == nil then return "" end;

	local CLASSNAME = "";

	for k,v in pairs (Turbine.Gameplay.Class) do
		if v == ID then return k end;
	end

	return CLASSNAME;

end

